﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;
using Telerik.Windows.Controls;

namespace TreeViewMultiSelect
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            List<Family> dataSource = new List<Family>();
          
            Family family = new Family();
            family.Name = "Simpson";
            dataSource.Add(family);
          
            family = new Family();
            family.Name = "Flanders";
            dataSource.Add(family);

            family = new Family();
            family.Name = "Smith";
            dataSource.Add(family);


            family = new Family();
            family.Name = "Johnson";
            dataSource.Add(family);


            family = new Family();
            family.Name = "Stevenson";
            dataSource.Add(family);

            this.Treeview.ItemsSource = dataSource;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            for (int i = 0; i < Treeview.ChildrenOfType<RadTreeView>()[0].Items.Count; i++)
            {
                // try to get the item Container  
                RadTreeViewItem childItemContainer = Treeview.ChildrenOfType<RadTreeView>()[0].ItemContainerGenerator.ContainerFromIndex(i) as RadTreeViewItem;
                if (childItemContainer != null)
                {
                    // DeSelect Item in list
                    //this.Dispatcher.BeginInvoke(new Action(() =>
                    //{
                    //    childItemContainer.IsSelected = false;
                    //    ((FamilyBase)childItemContainer.Item).IsSelected = false;
                    //    childItemContainer.BringIntoView();
                    //    childItemContainer.Focus();
                    //    childItemContainer.UpdateLayout();
                    //}), System.Windows.Threading.DispatcherPriority.ApplicationIdle);

                    Treeview.DeselectionTarget = childItemContainer;
                    childItemContainer.IsSelected = false;
                    Treeview.DeselectionTarget = null;
                }
            }
        }
        
    }


    public class FamilyBase : INotifyPropertyChanged
    {
        private bool isselected;
        public bool IsSelected
        {
            get
            {
                return isselected;
            }
            set
            {
                if (isselected != value)
                {
                    isselected = value;
                    OnPropertyChanged("IsSelected");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class Family : FamilyBase
    {
        public Family()
        {

        }
        public string Name
        {
            get;
            set;
        }
    }

    public class Member : FamilyBase
    {
        public Member(string name)
        {
            this.Name = name;
        }
        public string Name
        {
            get;
            set;
        }
    }

}
